# Critline

## [v4.6.15](https://github.com/Lombra/Critline/tree/v4.6.15) (2023-07-17)
[Full Changelog](https://github.com/Lombra/Critline/commits/v4.6.15) [Previous Releases](https://github.com/Lombra/Critline/releases)

- Set addon icon  
- Update readme  
- Fix minimap button lock setting  
- Adjust minimap button position for new minimap  
- Add README.md  
- Add BigWigs Packager build action  
- Fix opening options category  
- Fix display lock setting  
- Include LibDataBroker as external  
- Update tooltip level global strings  
- Use new tooltip parsing API  
- Update Libra external URL  
- Update ToC interface version  
- Ignore release output directory  
- Add `.gitignore`  
- Use backdrop template for AuraMonitor frame.  
-   
- - Use BackdropTemplate.  
-   
- - Fix sound file registration for LibSharedMedia.  
- - Fix spell tooltip spell ID debug info.  
-   
- - Fix spell tooltip hook.  
-   
- - Changelog.  
    - Fix aura monitor list item background.  
- - Update for 8.0 API.  
    - Lazy fix spell name to fall back on spell ID.  
-   
-   
-   
-   
-   
- - No git /trunk.  
- test  
-   
-   
- retry  
-   
-   
-   
-   
- - Confirm that known spell returns spell ID. (hint: it doesn't, for some spells)  
- - Update pkgmeta externals URLs.  
-   
- - Get LibDualSpec from GitHub.  
    - Add Trial of Valor, Tomb of Sargeras and Antorus NPC levels.  
    - PlaySound fixes.  
    - SetColorTexture changes.  
    - ToC bumps.  
- - Update repo and externals URLs.  
- Tagging as 4.6.7.  
- - Add Emerald Nightmare and Nighthold NPC levels.  
    - ToC bump.  
- Tagging as 4.6.6.  
- - Fix screenshot feature.  
- Tagging as 4.6.5.  
- - Add Hellfire Citadel NPC level.  
    - Add various filtered auras from Tanaan Jungle.  
    - ToC 60200.  
- Tagging as 4.6.4.  
- - Fix adding filtered mobs by name.  
    - Add filtered auras.  
    - Changelog.  
    - ToC bump.  
- Tagging as 4.6.3..  
- - Changelog.  
    - Add a bunch of WoD filtered auras.  
    - Add NP++ project file.  
- - Highmaul and Blackrock Foundry Bosses level 103.  
    - Fix visual bug with aura monitor search box.  
- - Use Phanx' library mirror for LibDualSpec instead of hard embedding.  
- Tagging as 4.6.2.  
- - Aura monitor ToC bump.  
    - Remove 'Don't filter magic' option.  
    - Update locales.  
- - Add hardcoded list of raid instance boss levels for proper level filtering.  
    - Set level filter to 1 by default.  
    - Add option to ignore boss creatures that are not in a raid instance. (their true level will not be recognised) Enabled by default.  
- - Don't include hard embedded copy of LibDualSpec. (the pkgmeta way)  
- - Don't include hard embedded copy of LibDualSpec.  
- - Update ToC interface version for AuraMonitor.  
- Tagging as 4.6.1.  
- - Update for GUID changes and updated libraries.  
- - Fix Reset/revert all buttons.  
- - Fully implement Libra.  
    - Remove some old upgrade code.  
    - Fix filter selection sometimes getting stuck.  
    - Add spell icons to filter lists.  
- - Implement Libra for taint free dropdowns and more widget stuff.  
- - Creature ID in GUIDs starts at the 6th bit, not the 7th.  
- - Aura monitor ToC bump.  
- - The aura tracker is now its own addon and was reworked heavily.  
    - Add many filtered auras.  
    - Remove custom filtered auras on login that exists in default filter.  
    - Properly update all scroll frames on login.  
    - Implement .pkgmeta and externals.  
    - ToC 5.4.  
- - Changelog.  
- - Update filter scroll frame on addon load.  
- - ToC bump.  
- - Add many filtered auras.  
    - Remove custom filtered auras on login that exists in default filter.  
    - Update scroll frames even if no parent is set. (UI options frame that wasn't shown yet)  
    - Minor template code cleanup.  
- - Add some filtered auras.  
- - Fix aura monitor right click menu check box.  
    - Add more Isle/Throne of Thunder auras.  
- - Filter Blood Infusion.  
    - Clean up some debug logic.  
    - Changelog.  
- - Don't create nolib packages.  
- - Use externals for working copy and implement .pkgmeta.  
    - "Clean" up folder structure a bit, capitalising file and folder names.  
    - Major rework of the aura tracker (now "monitor"), moved into its own addon.  
    - Add Taoshi's Hemorrhage ability to filtered auras.  
- - Tagging as 4.5.3.  
- - Update change log.  
    - Confirm Mogu Power aura.  
- - Add more filtered auras from Isle/Throne of Thunder and brawler's guild.  
- - Add some missed and new filtered auras.  
- - Add Determination (LFR wipe recovery) to aura filter.  
- - Fix error due to destName sometimes being nil, even when GUID is not.  
- Tagging as 4.5.2.  
- - Source GUID can now apparently be an empty string.  
    - ToC bumps.  
    - Add more auras.  
- - Tagging as 4.5.1.  
- - Update change log.  
- - Add more bad auras.  
    - Add button for reverting all eligible records.  
    - Make sure tooltip info is not added twice in the spell list when tooltip info is enabled.  
- - ToC bump.  
    - Merge player and target auras into a single table. This should allow custom aura filter to work for target auras.  
    - Add lots of filtered MoP buffs.  
- - Tagging as 4.5.0.  
- - Update libraries.  
- - Change log.  
- - 5.0 update. Not backwards compatible.  
    - Remove all types of hardcoded spell exceptions.  
    - "Known spells" now works off of spell names rather than IDs.  
    - Added advanced module as replacement for the spell exceptions. It allows for custom spell ID, tooltip, name and icon mappings. These are stored globally. (as opposed to profile specific)  
    - Added include filter to force spells to count as player spells, and exclude filter that completely ignores spells. Both accept spell IDs and names.  
    - Add a brief description to each filter type, explaining their purpose.  
    - Core:GetFullSpellName now requires a string instead of spell ID.  
    - Popup dialogs with editbox now won't let you accept if the input is invalid.  
    - Implement RegisterUnitEvent.  
    - Added a template for FauxScrollFrames.  
    - Spells that no longer exist in the game are now removed on load.  
    - Standardise the format of many debug messages.  
    - Spell name is now passed to NewRecord callback. (inserted as third argument)  
    - Organise the locales.  
    - Use simpler minimap buttin positioning logic.  
    - Make sure minimap button is not overlapped by minimap.  
    - Add a label to editbox template.  
- - Tagging as 4.4.0.  
- - Complete rewrite of config UI generation code. Create a subcategory using Critline.AddCategory and pass an array of options to config:CreateOptions(options[, module]). Widgets gets automatically created and positioned. Use config:LoadOptions() on addon load.  
    - Add a static popup template that automatically fills in a few common properties.  
    - Removed 'Play sound' option. You can just select 'None' on the dropdown.  
    - Sound is now off by default.  
    - Critline.Message and .Debug now accepts multiple arguments a la print.  
    - Option callback handlers now gets passed their new value instead of the module.  
    - 'Ignore aura filter' should now work properly when toggled.  
    - Add a texture to the splash frame indicating its hit box that's shown when unlocking the splash frame.  
    - Add an option to control the fade duration of the splash frame.  
- - Merge the functionalities of the spell filter, reset module and announce module into a new spell list module. Options are accessed via button. Add options with spellList:AddSpellOption(option), where option is a table containing info for a dropdown menu item.  
    - This renders the list template obsolete, so it's removed.  
    - Error if reset or announce modules load without spellList module being present.  
    - Don't use localisation for aura tracker.  
    - Publish a simple tree data table containing label, title (label with upper case initial letter) and icon. (Critline.trees["tree"])  
    - Also an array of the tree keys for when an ordered list is needed. (Critline.treeIndex)  
    - Fire a "FormatChanged" callback instead of "OnNewTopRecord" when toggling the short format option.  
    - Remove conversion code and checks for pre-4.0 upgrades.  
    - Don't pass parent name to template.CreateConfigFrame as it's always the same. Instead pass boolean isParent. (moved from second to fourth parameter)  
    - Register OnTreeStateChanged callback on display instead of trying to update the display from the tree toggle function, since we were already firing the callback anyway.  
    - Default spell tooltips to enabled.  
    - Add monk tree defaults.  
    - Add Korean and simplified Chinese locales.  
    - Slightly increase the width of the display when using labels.  
    - Add option to change the opacity of the display border.  
    - Use smarter logic to determine display layout.  
    - Fix custom aura filter.  
    - Slightly modify the appearance of the filter list. Use tabs instead of dropdown for filter selection.  
    - Scrap templates.CreateButton in favour of UIPanelButtonTemplate. (which becomes nice in MoP)  
    - Resetting a record now also clears any previous record it had.  
    - Implement a simple tab interface template.  
- - Filter heroic 25 man version of Feedback (Al'akir).  
- - Tagging as 4.3.0.  
- - Fix a few filtered auras from Blackwing Descent.  
- - Update change log and ToC.  
    - Group auras by content.  
- - Use UNIT\_AURA to track filtered player spells instead of combat log event, which does not fire for all auras. More CPU intensive, but worth it. (?)  
    - Add Beach Head Control to aura filter.  
    - Recognise Vampiric Embrace and Improved Devouring Plague as player spells.  
    - In aura tracker, complement UNIT\_AURA with source info if a combat log event fires later.  
    - Pass owner module to check button functions.  
- - Add Pure Water and Dizzy to aura filter.  
- - Add Infernal Defense and Sacrifice of Anveena (Sunwell Plateau) to aura filter.  
- - Register UNIT\_AURA to let aura tracker pick up auras that does not trigger a combat log event.  
    - Add Fel Rage (Gurtogg Bloodboil), Primsatic auras (Mother Shahraz), Shadow Walk (Well of Eternity, additional spell ID), Ysera's and Kalecgos's Presences and Expose Weakness to aura filters.  
    - Add Ancestral Awakening, Cleansing Waters, Echo of Light, Holy Words: Serenity and Sanctuary to player spells.  
    - Use more aggressive aura filtering; as soon as you gain a filtered aura, no more records will be registered for the remainder of the encounter, and no more records will be registered on a target once it's gained a filtered aura. (even after it fades, in both cases)  
- - ToC bump.  
    - Recognise Improved Serpent Sting, Fulmination, Starfall, Typhoon and Mushroom detonation as player spells and show records on tooltips.  
    - Use static icon for wand shoot spell.  
    - Add Risen Ghoul (End Time) to mob filter.  
    - Add to several auras from Hour of Twilight dungeons and Dragon Soul to filters.  
    - Revmove crazy killing blow record protection. (temporary solution)  
- - Tagging as 4.2.0  
- - Update change log and ToC.  
- - Warlocks' infernal damage can now be registered.  
    - Add exceptions for Heroic Leap, Blood Plague, Frost Fever, ghoul abilities, Demon Leap, Immolation Aura and Felstorm.  
    - Add spell ID to tooltips when debugging is enabled.  
    - Filter Sayge's Dark Fortune of Damage, Sara's Fervor and another version of Spirit's Vengeance.  
    - Add a bunch of spells to be recognised by the player spells only-option.  
    - Pet auto attacks will now work with the player spells only-option.  
- - Add frFR localisation.  
    - Fix localisation keywords.  
- - Added tooltip exception for Flame Orb.  
    - Added Bethekk's Blessing and Concentration (heroic Staghelm) to aura filter.  
    - Revert change that enabled periodic effects on vulnerable targets that were applied before the vulnerability to be registered. (too unreliable)  
    - Made the filter type dropdown reappear.  
    - Use repository keywords for locale files.  
- - Split filter engine and GUI into two different files. They remain dependent of each other.  
    - Resetting spells should now be reflected in the filter list.  
- - Merge spell ID mapping into a single table where all spell effect IDs are mapped to its corresponding tooltip ID. All spells are now registered using their tooltip ID.  
    - Register Bladestorm Whirlwind attacks as "Bladestorm".  
    - Use more appropriate global strings to find the target's level. Should now work on all locales.  
    - Add option to set the opacity of the display backdrop.  
    - Add Erudax back into the mob filter. Shadow Gale cannot be tracked.  
    - Add Empowered Blood, Empowering Twilight, Flames of the Firehawk, Vulnerable and Burnout to aura filters.  
    - Move Imprinted from target auras to player auras.  
    - Stacking periodic effects can now properly be filtered by filtered auras and mobs.  
    - The "player spells only" option should now work with more (hopefully all) player spells.  
    - Add exceptions for certain spells, such as off hand damage caused by abilities striking with both weapons, to be recognised as player spells.  
    - Give the minimap button a name to work better with certain third party addons.  
- - "Typo".  
- - Implemented (somewhat experimental) system to properly filter killing blows delivered to targets affected by filtered auras.  
    - Add Burden of the Crown, Imprinted, and Feedback (25) to aura filters.  
    - Tweak the config frames to adapt to the increased size of the interface options frame.  
- - Add Invocation of Flame, Antlers of Malorne and Infernal Rage to aura filters.  
- - Tagging as 4.1.1  
- - Add tooltip exception for Arcane Missiles.  
    - Add Corruption:Absolute (Cho'gall) to aura filter.  
    - Update combat log event code for patch 4.2.  
    - ToC bump.  
- - Register LibSharedMedia callbacks to notify us when new media is registered.  
    - Remove LibSharedMedia optional dependency.  
- - Revert .pkgmeta changes.  
    - Update change log.  
    - Remove Ace3 optional depedency.  
    - Update ToC addon version.  
- - Add tooltip exceptions for Slam, Feed Pet, Wyvern Sting, Intercept, Bloodthirst and Chimera Shot.  
- package?  
- - Specify custom change log. Testing packaging.  
- Add .pkgmeta, fix hard embeded libraries, update ToC with new libraries... you'll still need to fix a few more libs I believe.  Testing to see if addon will package now.  
- - Tagging as 4.1.0.  
- - Update change log.  
- - Remove WoWI property.  
- - Add High Priest Venoxis to mob filter.  
- - Do not ignore pet damage when player is mind controlled.  
- - Minor code cleanup.  
- - Remove water elemental from class pets as it's now treated as a permanent pet.  
    - Add Kill Command tooltip exception.  
    - Move aura tracker out of the filter module and into its own module.  
    - Aura tracker should now pick up auras even when no source was provided.  
    - Pet damage will now obey aura filtering.  
    - Fix error occuring upon attacking filtered targets.  
    - Add Berserking (battlegrounds), Spirit's Vengeance (Bloodord Mandokir) and Sunder Rift (Jin'do) to aura filters.  
    - Add new spell IDs for some Cataclysm raid auras.  
    - Add Ragezone (normal mode Deadmines), and remove it from target aura, since it no longer increases damage taken.  
    - Periodic healing done to yourself while under the effects of a filtered (healing-received-increased) aura should now be properly filtered.  
    - Periodic effects can now be registered if it ticks on a vulnerable target, as long as the effect was applied before the vulnerability aura. (somewhat experimental)  
    - Spells in the reset and announce lists will now be grayed out if they're filtered.  
    - Toggling short number format should no longer affect the Broker objects whose tree is disabled.  
- Tagging as 4.0.3  
- - Add Sweeping Strikes and Aimed Shot! exceptions.  
    - Remove pre-4.1 compability code.  
    - Update ToC interface and version.  
    - Update filter module combat log event handler for 4.1.  
- Tagging as 4.0.2.  
- - Hunter traps will now properly display tooltip records.  
    - "Include old record" moved from splash module to core. Applies to both chat frame and splash messages.  
    - Second attempt at including old record in chat frame output.  
    - Made critical record message in the chat frame slightly more distinguishable from a non crit.  
    - Do not show pet auto attack records in the regular auto attack tooltip.  
- - Changed a few debugs to be slightly more useful.  
- Tagging as 4.0.1.  
- - Updated version number.  
- - You can now specify the sound effect played on new records. (LibSharedMedia)  
    - Pet auto attack records are now displayed on the pet attack action tooltip.  
    - Added Hellscream's Warsong, Strength of Wrynn, Singed and Chemical Cloud to aura filters.  
- - Fix an updated localisation string.  
- - Records printed to the chat frame can now be shortened, and can once again include the previous record.  
    - Added Aerial Command Unit back to mob filter. Not eligible for aura tracking.  
    - Splash frame records can now be shortened when no previous record is included in the message.  
    - Do not try to load AceDBOptions since we're not using it.  
- Tagging as 4.0.0.  
-  Core:  
    * Rewrote database to store spells by ID rather than name. This is more flexible and opens up a few possibilities.  
    * Most spells will be carried over to the new database, but others (mostly procs and item effects) will be lost.  
    - Absorb effects are now stored as healing records. Uses the remaining absorb amount when you apply shields.  
    - Added option to use shorter number format for records. (eg 13 k instead of 13000)  
    - Added option to display records in its spell's tooltip.  
    - Spells that have different versions, but identical effects, (such as "Pyroblast!" and "Ravage!") are now treated as one and the same.  
    - Added compability for patch 4.1.  
    - Certain guardian type pets should once again have their records properly registered.  
    - Periodic damage is now annotated by an asterisk (*) or the word "tick" rather than DoT/HoT.  
    - Removed some legacy code.  
    - Some code and performance optimisation.  
     Filter:  
    - Implemented basic filtering based on target auras. For now you have to be in combat log range when an aura is applied or removed for the addon to register it. See filters.lua for details.  
    - Implemented a basic aura tracker (mostly for debugging purposes). Type '/critline aura' to show or hide it.  
    - Removed option to invert spell filter. From now on unchecked spells are filtered, and new spells are not filtered by default.  
    - Added option to automatically filter newly registered spells. (disabled by default)  
    - Spell filter now shows spell tooltip and associated records on mouseover.  
    - Spells with no records are no longer kept in the database for the purpose of saving its filter flag.  
    - Added Drakeadon Mongrel and Exposed Head of Magmaw to mob filter.  
    - Added Power Generator, Engulfing Magic, Lightning Charge and Blessing of the Sun (heroic) to aura filter.  
     Display:  
    - The different panels' background color can now be changed as desired.  
    - The frame can now be scaled up to 200%. (from 150%)  
    - The frame's alpha can now be changed.  
    - It should no longer be possible to force show the frame when no trees are enabled, resulting in a weird appearance.  
    - Reset and announce spell lists had their appearance redesigned. Click to directly to your thing, instead of checking and then clicking.  
    - New records achieved in the last fight can now be undone in the reset module. Eligible spells will have a different button.  
    - Spell profiles should now display the correct used profiles at all times.  
    - Updated libraries.  
- - Added Erudax to mob filter.  
    - New spell ID for Tidal Surge.  
- Tagging as 3.1.3.  
- - Added Karsh Steelbender, Ragnaros (Mount Hyjal) and Debilitated Apexar to mob filter.  
    - Added Tidal Surge, Pyrogenics, Blessing of the Sun, Empowering Twilight,  
      Invocation of Flame, Red Mist, Ragezone and Frothing Rage to aura filter.  
- Tagging as 3.1.2.  
- - Disabled adding spells to filter from the spell book to avoid tainting.  
    - Removed leftover debugging for when moving the display frame.  
- - Clicking the Announce button rather than pressing enter should now properly announce.  
    - Added support for LibSharedMedia for selecting splash font.  
- 3.1.1  
    - Fixed adding spells to filter from the spell book.  
    - Fixed display moving on login when using a scale other than 100%.  
- - another test  
- - new test  
- - borked?  
- 3.1.1  
    - Fixed adding spells to filter from the spell book.  
    - Fixed display moving on login when using a scale other than 100%.  